import 'dart:async';

import 'package:flutter/services.dart';

typedef RewardResult = void Function(bool result);

class FlutterAds {
  static const MethodChannel _channel = const MethodChannel('flutter_ads');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static const BasicMessageChannel<dynamic> rewardMessageChannel =
      const BasicMessageChannel('plugins.nova.ads.event/reward', StringCodec());

  static Future initRewardVideo(String appKey, String codeId, String userId,
      {int orientation = 0,
      String rewardName = "金币",
      String rewardAmount = "3",
      String mediaExtra = "media_extra",
      RewardResult callback}) async {
    var params = {
      "appKey": appKey,
      "codeId": codeId,
      "userId": userId,
      "orientation": orientation == 0 ? "V" : "H",
      "rewardName": rewardName,
      "rewardAmount": rewardAmount,
      "mediaExtra": mediaExtra
    };
    await _channel.invokeMethod('initRewardVideo', params);
  }

  static Future loadRewardVideo() async {
    await _channel.invokeMethod('loadRewardVideo');
  }
}
